<ui:composition xmlns:g="http://www.ihe.net/gazelle" xmlns:a4j="http://richfaces.org/a4j"
                xmlns:f="http://java.sun.com/jsf/core" xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns:rich="http://richfaces.org/rich" xmlns:c="http://java.sun.com/jstl/core"
                xmlns:s="http://jboss.org/schema/seam/taglib" xmlns:p="http://primefaces.org/ui"
                xmlns:h="http://java.sun.com/jsf/html" xmlns="http://www.w3.org/1999/xhtml"
                template="/layout/template.xhtml">
    <ui:define name="body">
        <h2>#{messages['net.ihe.gazelle.xval.EditRule_2']}</h2>
        <rich:dragIndicator id="indicator" draggingClass="gzl-btn gzl-btn-blue">
            #{messages['net.ihe.gazelle.xval.Expression']}
        </rich:dragIndicator>
        <h:outputText value="#{messages['net.ihe.gazelle.xval.WrongParametersInURL']}"
                      rendered="#{ruleEditorManager.newRule == null}"/>
        <s:div id="globalDiv" rendered="#{ruleEditorManager.newRule != null}">
            <h:form id="globalForm">
                <s:decorate template="/layout/panels/_panel_title_footer.xhtml"
                            rendered="#{ruleEditorManager.newRule != null}">
                    <ui:param name="panel_id" value="ruleAttributes"/>
                    <ui:define name="panel_title">
                        <h:outputText value="#{messages['net.ihe.gazelle.xval.RuleDetails']}"/>
                    </ui:define>
                    <div class="row">
                        <div class="col-md-6">
                            <dl>
                                <s:decorate template="/layout/display/_data_list_item.xhtml">
                                    <ui:define name="label">#{messages['net.ihe.gazelle.xval.GazelleCrossValidator']}
                                    </ui:define>
                                    <g:link value="#{ruleEditorManager}"/>
                                </s:decorate>
                            </dl>
                            <a4j:region>
                                <s:div id="devSection"
                                       rendered="#{ruleEditorManager.newRule.id == null or ruleEditorManager.newRule.isValidatorUnderDevelopment() or ruleEditorManager.newRule.isCopy()}">
                                    <s:decorate template="/layout/form/_edit.xhtml">
                                        <ui:param name="id" value="keywordInput"/>
                                        <ui:define name="label">#{messages['net.ihe.gazelle.xval.Keyword']}</ui:define>
                                        <h:inputText styleClass="form-control" id="keywordInput"
                                                     value="#{ruleEditorManager.newRule.keyword}" required="true"
                                                     requiredMessage="A keyword is required for this rule"
                                                     validator="#{ruleEditorManager.validateRuleKeyword}"/>
                                    </s:decorate>
                                    <s:decorate template="/layout/form/_edit.xhtml">
                                        <ui:param name="id" value="versionInput"/>
                                        <ui:define name="label">#{messages['net.ihe.gazelle.xval.Version_2']}
                                        </ui:define>
                                        <h:inputText styleClass="form-control" id="versionInput"
                                                     value="#{ruleEditorManager.newRule.version}" required="true"
                                                     requiredMessage="A version is required for this rule"/>
                                    </s:decorate>
                                </s:div>
                                <s:div id="maintenanceSection"
                                       rendered="#{ruleEditorManager.newRule.id != null and ruleEditorManager.newRule.isValidatorUnderMaintenance() and not (ruleEditorManager.newRule.isCopy())}">
                                    <dl>
                                        <s:decorate template="/layout/display/_data_list_item.xhtml">
                                            <ui:define name="label">#{messages['net.ihe.gazelle.xval.Keyword']}
                                            </ui:define>
                                            <h:outputText value="#{ruleEditorManager.newRule.keyword}"/>
                                        </s:decorate>
                                        <s:decorate template="/layout/display/_data_list_item.xhtml">
                                            <ui:define name="label">#{messages['net.ihe.gazelle.xval.Version_2']}
                                            </ui:define>
                                            <h:outputText value="#{ruleEditorManager.newRule.version}"/>
                                        </s:decorate>
                                    </dl>
                                </s:div>
                                <s:decorate template="/layout/form/_edit.xhtml">
                                    <ui:param name="id" value="severityInput"/>
                                    <ui:define name="label">#{messages['net.ihe.gazelle.xval.Severity']}</ui:define>
                                    <br/>
                                    <h:selectOneMenu value="#{ruleEditorManager.newRule.level}" required="true"
                                                     requiredMessage="Please select a level of severity for this rule"
                                                     styleClass="form-control gzl-form-control gzl-select-text" id="severityInput">
                                        <f:selectItems value="#{ruleEditorManager.getSeverities()}"/>
                                    </h:selectOneMenu>
                                </s:decorate>
                                <dl>
                                    <s:decorate template="/layout/display/_data_list_item.xhtml">
                                        <ui:define name="label">#{messages['net.ihe.gazelle.xval.Status']}</ui:define>
                                        <h:outputText value="#{ruleEditorManager.newRule.status.value()}"/>
                                    </s:decorate>
                                </dl>
                                <s:decorate template="/layout/form/_edit.xhtml">
                                    <ui:param name="id" value="descInput"/>
                                    <ui:define name="label">#{messages['net.ihe.gazelle.xval.Description']}</ui:define>
                                    <h:inputTextarea styleClass="form-control" id="descInput"
                                                     value="#{ruleEditorManager.newRule.description}"
                                                     required="true" style="resize:both"
                                                     requiredMessage="The description of the rule is required"/>
                                </s:decorate>
                                <dl>
                                    <s:decorate template="/layout/display/_data_list_item.xhtml"
                                                rendered="#{ruleEditorManager.newRule.id != null}">
                                        <ui:define name="label">#{messages['net.ihe.gazelle.xval.TextualExpression']}
                                        </ui:define>
                                        <code>
                                            <h:outputText value="#{ruleEditorManager.newRule.textualExpression} "
                                                          rendered="#{not empty ruleEditorManager.newRule.textualExpression}"
                                                          escape="false"/>
                                        </code>
                                        <h:outputText
                                                value="#{messages['net.ihe.gazelle.xval.NoExpressionDefinedYet']} "
                                                rendered="#{empty ruleEditorManager.newRule.textualExpression}"
                                                style="color:red;font-weight:bold;"/>
                                        <a4j:commandLink title="#{messages['net.ihe.gazelle.xval.EditExpression']}"
                                                         actionListener="#{ruleEditorManager.editExpression()}"
                                                         render="globalDiv">
                                            <s:span styleClass="fa fa-pencil gzl-text-blue"/>
                                        </a4j:commandLink>
                                    </s:decorate>
                                    <s:decorate template="/layout/display/_data_list_item.xhtml"
                                                rendered="#{not empty ruleEditorManager.newRule.lastModifiedDate}">
                                        <ui:define name="label">#{messages['net.ihe.gazelle.xval.LastModifiedOn']}
                                        </ui:define>
                                        <g:date value="#{ruleEditorManager.newRule.lastModifiedDate}"/>
                                    </s:decorate>
                                    <s:decorate template="/layout/display/_data_list_item.xhtml"
                                                rendered="#{not empty ruleEditorManager.newRule.lastModifier}">
                                        <ui:define name="label">#{messages['net.ihe.gazelle.xval.LastModifiedBy']}
                                        </ui:define>
                                        <h:outputText value="#{ruleEditorManager.newRule.lastModifier}"/>
                                    </s:decorate>
                                </dl>
                            </a4j:region>
                        </div>
                        <div class="col-md-6">
                            <a4j:region>
                                <ui:include src="/xvalidation/expressions/_expressionEditor.xhtml"/>
                            </a4j:region>
                        </div>
                    </div>
                    <ui:define name="panel_footer">
                        <a4j:commandButton value="#{messages['net.ihe.gazelle.xval.Back']}"
                                           action="#{ruleEditorManager.back()}" byPassUpdates="true"
                                           immediate="true" styleClass="gzl-btn"
                                           title="#{messages['net.ihe.gazelle.xval.UnsavedChangesWillBeLost']}"/>
                        <a4j:commandButton value="#{messages['net.ihe.gazelle.xval.Save']}"
                                           actionListener="#{ruleEditorManager.saveRule()}" styleClass="gzl-btn-green"
                                           disabled="#{ruleEditorManager.editMode}" render="globalDiv"/>
                        <s:div styleClass="btn-group" rendered="#{ruleEditorManager.canChangeRuleStatus()}">
                            <button type="button" class="btn gzl-btn-blue dropdown-toggle" data-toggle="dropdown"
                                    aria-haspopup="true" aria-expanded="false">#{messages['net.ihe.gazelle.xval.MarkAs']} <span class="caret"/>
                            </button>
                            <ul class="dropdown-menu">
                                <li>
                                    <a4j:commandLink
                                            value="#{ruleUpdateManager.availableStatus(ruleEditorManager.newRule)}"
                                            actionListener="#{ruleUpdateManager.setRule(ruleEditorManager.newRule)}"
                                            oncomplete="jq162('#changeRuleStatusPanel').modal('show');"
                                            render="changeRuleStatusPanelContent"/>
                                </li>
                                <li>
                                    <a4j:commandLink value="#{messages['net.ihe.gazelle.xval.Deprecated']}"
                                                     actionListener="#{ruleUpdateManager.setRule(ruleEditorManager.newRule)}"
                                                     oncomplete="jq162('#deprecateRulePanel').modal('show');"
                                                     render="deprecateRulePanelContent"/>
                                </li>
                            </ul>
                        </s:div>
                        <s:div styleClass="btn-group" rendered="#{ruleEditorManager.canChangeRuleStatus()}">
                            <button type="button" class="btn gzl-btn-blue dropdown-toggle" data-toggle="dropdown"
                                    aria-haspopup="true" aria-expanded="false">#{messages['net.ihe.gazelle.xval.MoreActions']} <span class="caret"/>
                            </button>
                            <ul class="dropdown-menu">
                                <li>
                                    <a4j:commandLink value="#{messages['net.ihe.gazelle.xval.DuplicateThisRule']}"
                                                     action="#{ruleEditorManager.duplicateRule()}"
                                                     byPassUpdates="true" immediate="true"
                                                     title="#{messages['net.ihe.gazelle.xval.UnsavedChangesWillBeLost']}"/>
                                </li>
                                <li>
                                    <a4j:commandLink value="#{messages['net.ihe.gazelle.xval.CreateANewRule']}"
                                                     action="#{ruleEditorManager.createANewRule()}"
                                                     byPassUpdates="true" immediate="true"
                                                     title="#{messages['net.ihe.gazelle.xval.UnsavedChangesWillBeLost']}"/>
                                </li>
                            </ul>
                        </s:div>
                    </ui:define>
                </s:decorate>
                <br/>
                <s:decorate template="/layout/panels/_panel_title.xhtml"
                            rendered="#{not ruleEditorManager.editMode and not empty ruleEditorManager.newRule.expression}">
                    <ui:define name="panel_title">
                        <h:outputText value="#{messages['net.ihe.gazelle.xval.Inputs']}"/>
                    </ui:define>
                    <h:outputText
                            value="#{messages['net.ihe.gazelle.xval.TheTableBelowGathersTheInputsUsedTheValidatorWhi']}"/>
                    <s:decorate template="/xvalidation/common/validatorInputsTable.xhtml">
                        <ui:param name="inputs" value="#{ruleEditorManager.ruleInputs}"/>
                        <ui:define name="actionButtons">
                            <a4j:commandLink styleClass="action"
                                             title="#{messages['net.ihe.gazelle.xval.DisplayReferencedObject']}"
                                             id="displayReferencedObject"
                                             action="#{xvalidatorEditorManager.redirectToReferencedObjectDoc(input)}">
                                <s:span styleClass="gzl-icon-search"/>
                            </a4j:commandLink>
                        </ui:define>
                    </s:decorate>
                </s:decorate>
                <br/>
                <ui:include src="/xvalidation/common/displayConfiguration.xhtml">
                    <ui:param name="configuration" value="#{ruleEditorManager.validatorConfiguration}"/>
                </ui:include>
                <br/>
                <s:decorate template="/layout/panels/_panel_title.xhtml" id="assertions"
                            rendered="#{ruleEditorManager.newRule.id != null}">
                    <ui:define name="panel_title">
                        <h:outputText value="#{messages['net.ihe.gazelle.xval.CoveredAssertions']}"/>
                    </ui:define>
                    <s:decorate template="/layout/panels/_panel.xhtml"
                                rendered="#{not empty ruleEditorManager.newRule.assertions}">
                        <ui:param name="styleClass" value="panel-info"/>
                        <a4j:region>
                            <ul>
                                <a4j:repeat value="#{ruleEditorManager.newRule.assertions}" var="assert">
                                    <li>
                                        <h:outputLink value="#{assertionManager.getAssertionLink(assert)}"
                                                      target="blank">
                                            <h:outputText value="#{assert.assertionId} (#{assert.idScheme})"/>
                                        </h:outputLink>
                                        <a4j:commandLink render="assertions"
                                                         actionListener="#{ruleEditorManager.removeAssertion(assert)}"
                                                         title="#{messages['net.ihe.gazelle.xval.RemoveAssertionFromList']}">
                                            <s:span styleClass="fa fa-trash-o gzl-text-red"/>
                                        </a4j:commandLink>
                                    </li>
                                </a4j:repeat>
                            </ul>
                        </a4j:region>
                    </s:decorate>
                    <h:outputText
                            value="#{messages['net.ihe.gazelle.xval.UseTheListBelowToSelectAnIdSchemeAndThenSelectTh']}"
                            styleClass="help-block"/>
                    <s:div id="assertList">
                        <ui:decorate template="/layout/form/_edit.xhtml">
                            <ui:param name="id" value="searchAssert"/>
                            <ui:define name="label">
                                #{messages['net.ihe.gazelle.xval.IdScheme']}
                            </ui:define>
                            <br/>
                            <h:selectOneMenu value="#{ruleEditorManager.searchedIdScheme}"
                                             id="searchAssert" styleClass="form-control gzl-select-text">
                                <s:selectItems value="#{ruleEditorManager.availableSchemes}"
                                               var="sch" label="#{sch}" noSelectionLabel="#{messages['net.ihe.gazelle.xval.PleaseSelect']}"/>
                                <a4j:ajax event="change" listener="#{ruleEditorManager.listAssertions()}"
                                          render="assertList"/>
                            </h:selectOneMenu>
                        </ui:decorate>
                        <rich:dataTable value="#{ruleEditorManager.availableAssertions}"
                                        var="assert" render="dsAssert"
                                        rows="#{dataScrollerMemory.numberOfResultsPerPage}"
                                        rendered="#{ruleEditorManager.searchedIdScheme != null}"
                                        id="wsAssertionTable">
                            <g:column>
                                <ui:define name="header">#{messages['net.ihe.gazelle.xval.IdScheme_2']}</ui:define>
                                <h:outputText value="#{assert.idScheme}"/>
                            </g:column>
                            <g:column>
                                <ui:define name="header">#{messages['net.ihe.gazelle.xval.AssertionID']}</ui:define>
                                <h:outputText value="#{assert.assertionId}"/>
                            </g:column>
                            <g:column>
                                <ui:define name="header">#{messages['net.ihe.gazelle.xval.Description']}</ui:define>
                                <h:outputText value="#{assert.description}"/>
                            </g:column>
                            <g:column>
                                <ui:define name="header">#{messages['net.ihe.gazelle.xval.Action']}</ui:define>
                                <a4j:commandButton actionListener="#{ruleEditorManager.addAssertion(assert)}"
                                                   styleClass="gzl-btn gzl-btn-green"
                                                   value="#{messages['net.ihe.gazelle.xval.Link']}"
                                                   render="assertions"
                                                   rendered="#{not ruleEditorManager.isLinked(assert)}"/>
                                <a4j:commandButton actionListener="#{ruleEditorManager.removeAssertion(assert)}"
                                                   styleClass="gzl-btn gzl-btn-red"
                                                   value="#{messages['net.ihe.gazelle.xval.Unlink']}"
                                                   render="assertions"
                                                   rendered="#{ruleEditorManager.isLinked(assert)}"/>
                            </g:column>
                            <f:facet name="footer">
                                <ui:include src="/util/datatableFooter.xhtml">
                                    <ui:param name="dataScrollerId" value="dsAssert"/>
                                    <ui:param name="dataTableId" value="wsAssertionTable"/>
                                </ui:include>
                            </f:facet>
                        </rich:dataTable>
                    </s:div>
                </s:decorate>
                <s:decorate template="/layout/panels/_panel_title.xhtml"
                            rendered="#{ruleEditorManager.newRule.id != null}">
                    <ui:define name="panel_title">
                        <h:outputText value="#{messages['net.ihe.gazelle.xval.UnitTests']}"/>
                    </ui:define>

                    <a4j:region>
                        <div class="btn-group">
                            <button type="button" class="btn gzl-btn-blue dropdown-toggle" data-toggle="dropdown"
                                    aria-haspopup="true" aria-expanded="false">#{messages['gazelle.vut.Actions']} <span class="caret"/>
                            </button>
                            <ul class="dropdown-menu">
                                <li>
                                    <a4j:commandLink value="#{messages['net.ihe.gazelle.xval.CreateANewUnitTest']}"
                                                     action="#{ruleUnitTestManager.createNewTest(ruleEditorManager.newRule)}"/>
                                </li>
                                <li>
                                    <a4j:commandLink value="#{messages['net.ihe.gazelle.xval.ExecuteAllUnitTests']}"
                                                     actionListener="#{ruleUnitTestManager.executeAllTests(ruleEditorManager.newRule)}"
                                                     render="ruleUnitTestTableForm"/>
                                </li>
                                <li>
                                    <a4j:commandLink value="#{messages['net.ihe.gazelle.xval.AccessAllLogs']}"
                                                     action="#{ruleUnitTestManager.displayRuleUnitTestLogs(ruleEditorManager.newRule)}"/>
                                </li>
                                <li>
                                    <a4j:commandLink value="#{messages['net.ihe.gazelle.xval.AccessLogsForCurrentVersion']}"
                                                     action="#{ruleUnitTestManager.displayRuleVersionUnitTestLogs(ruleEditorManager.newRule)}"/>
                                </li>
                            </ul>
                        </div>
                    </a4j:region>
                    <s:decorate template="/unittesting/unitTestTable.xhtml">
                        <ui:param name="listOfUnitTests" value="#{ruleEditorManager.getUnitTests()}"/>
                        <ui:param name="utManagerBean" value="#{ruleUnitTestManager}"/>
                        <ui:param name="formToRender" value="#{messages['net.ihe.gazelle.xval.GlobalForm']}"/>
                        <ui:define name="additionalColumns1">
                            <g:column>
                                <ui:define name="header">#{messages['gazelle.vut.Active']}</ui:define>
                                <h:outputText value="#{messages['net.ihe.gazelle.xval.Yes']}" rendered="#{ut.active}"/>
                                <h:outputText value="#{messages['net.ihe.gazelle.xval.No']}" rendered="#{not ut.active}"/>
                            </g:column>
                            <g:column sortBy="#{'expectedResult'}">
                                <ui:define name="header">#{messages['gazelle.vut.ExpectedResult']}</ui:define>
                                <h:outputText value="#{ut.expectedResult}"/>
                            </g:column>
                        </ui:define>
                        <ui:define name="additionalColumns2">
                            <g:column>
                                <ui:define name="header">#{messages['gazelle.vut.ReasonForFailure']}</ui:define>
                                <h:outputText value="#{ut.reasonForFailure}"/>
                            </g:column>
                        </ui:define>
                    </s:decorate>
                </s:decorate>
            </h:form>
        </s:div>
        <ui:include src="/xvalidation/admin/deprecateRulePanel.xhtml">
            <ui:param name="idsToRerender" value="globalForm"/>
        </ui:include>
        <ui:include src="/xvalidation/admin/changeRuleStatusPanel.xhtml"/>
        <ui:include src="/xvalidation/expressions/moveToAlert.xhtml"/>
    </ui:define>
</ui:composition>
